=== modified file 'NEWS'
--- NEWS	2009-06-04 11:05:37 +0000
+++ NEWS	2009-06-05 07:10:13 +0000
@@ -20,9 +20,6 @@
 New Features
 ************
 
-* The number of cores is also detected on Solaris and win32. (Vincent Ladeuil)
-
-
 Improvements
 ************
 
@@ -78,6 +75,8 @@
 Testing
 *******
 
+* The number of cores is also detected on Solaris and win32. (Vincent Ladeuil)
+
 
 bzr 1.15
 ########

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2009-06-04 11:05:37 +0000
+++ bzrlib/osutils.py	2009-06-05 07:10:13 +0000
@@ -1847,8 +1847,7 @@
                                 stdout=subprocess.PIPE).communicate()[0]
 elif sys.platform == "win32":
     def _local_concurrency():
-        # FIXME: If NUMBER_OF_CORES is available somewhow, it will be more
-        # precise
+        # This appears to return the number of cores.
         return os.environ.get('NUMBER_OF_PROCESSORS')
 else:
     def _local_concurrency():
@@ -1856,12 +1855,18 @@
         return None
 
 
-def local_concurrency():
+_cached_local_concurrency = None
+
+def local_concurrency(use_cache=True):
     """Return how many processes can be run concurrently.
 
     Rely on platform specific implementations and default to 1 (one) if
     anything goes wrong.
     """
+    global _cached_local_concurrency
+    if _cached_local_concurrency is not None and use_cache:
+        return _cached_local_concurrency
+
     try:
         concurrency = _local_concurrency()
     except (OSError, IOError):
@@ -1870,4 +1875,6 @@
         concurrency = int(concurrency)
     except (TypeError, ValueError):
         concurrency = 1
+    if use_cache:
+        _cached_concurrency = concurrency
     return concurrency

